/*
 * SIM800Core.hpp
 * 
 * Copyright 2014 Stefan Mavrodiev <support@olimex.com>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 */
#ifndef __SIM800Core.h__
#define __SIM800Core.h__

#include <SIM800HostCommunication.hpp>

class SIM800Core
{
    private:
    
        
    
    public:
        SIM800HostCommunication host;
        SIM800Core();
        /**
         * Send poweroff ATcommand
         * 
         * @param   isUrgent    Power off urgently or normal
         * @return  If the operation was successful or not
         */
        bool SWPowerOff(bool isUrgent=false);
        
        /**
         * Power on the board by setting D11 pin HIGH for 2 seconds.
         * After that test if the board is responding wit AT command.
         * 
         * @return If the board is responding after the power up
         */
        bool HWPowerOn();
        
        /**
         * Power off the board by setiing D11 pin HIGH for 2 seconds.
         * After that test if the board is alive.
         * 
         * @return If the board is alive
         */
         bool HWPowerOff();
         
         /**
          * Check if SIM800 is alive
          * 
          * @return If board board is active
          */
          bool isAlive();  
};

#endif
